config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check

  # Render dynamic PWA files from app/views/pwa/* (remember to link manifest in application.html.erb)
  # get "manifest" => "rails/pwa#manifest", as: :pwa_manifest
  # get "service-worker" => "rails/pwa#service_worker", as: :pwa_service_worker

  # Defines the root path route ("/")
  # root "posts#index"
  scope module: "oni_sorceress" do
    get "allfeed.atom" => "outer_comm/atom#index", as: :allfeed_atom, format: false
    get "robots.txt" => "outer_comm/robots_txt#show", as: :robots_txt, format: false
    get "sitemap.xml" => "outer_comm/sitemap_xml#show", as: :sitemap_xml, format: false

    scope module: "front" do
      get "browse", to: "browse_by_category#index"
      get "categories/:first_level", to: "first_level_category#show", as: "first_level_category"
      get "categories/:first_level/:second_level", to: "second_level_category#show", as: "second_level_category"

      resources :articles, only: [:index, :show] do
        resources :comments, only: :create
      end
      resources :authors, only: :show

      root to: "beginnings#index"
    end

    scope module: "web_services" do
      resource :what_is_my_ip_address, only: :show
    end

    namespace "administration" do
      resources :style_guide, only: :index, if: -> { Rails.env.development? } do
        collection do
          get :articles
          get :articles_mobile
        end
      end

      namespace :moderation do
        resources :comments, only: [:index]
      end
    end
  end
end

app/models/oni_sorceress/analytics.rb
# frozen_string_literal: true

module ::OniSorceress::Analytics
  def self.table_name_prefix
    "oni_sorceress_analytics_"
  end
end

app/models/oni_sorceress/analytics/bogofilter_ham.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_analytics_bogofilter_hams
#
#  id                                     :uuid             not null, primary key
#  learn_state                            :integer          default("not_learned"), not null
#  oni_sorceress_bogofilter_hammable_type :string           not null
#  created_at                             :datetime         not null
#  updated_at                             :datetime         not null
#  oni_sorceress_bogofilter_hammable_id   :uuid             not null
#
# Indexes
#
#  index_oni_sorceress_analytics_hams_on_hammable  (oni_sorceress_bogofilter_hammable_type,oni_sorceress_bogofilter_hammable_id)
#
class OniSorceress::Analytics::BogofilterHam < OniSorceressRecord
  include AASM

  belongs_to :oni_sorceress_bogofilter_hammable, polymorphic: true

  enum :learn_state, { not_learned: 0, learned: 1, unlearned: 2 }
  aasm :learn_state, enum: true do
    state :not_learned, initial: true
    state :learned
    state :unlearned

    event :learn, from: :not_learned, to: :learned
    event :unlearn, from: :learned, to: :unlearned
  end
end

app/models/oni_sorceress/analytics/bogofilter_spam.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_analytics_bogofilter_spams
#
#  id                                      :uuid             not null, primary key
#  learn_state                             :integer          default("not_learned"), not null
#  oni_sorceress_bogofilter_spammable_type :string           not null
#  created_at                              :datetime         not null
#  updated_at                              :datetime         not null
#  oni_sorceress_bogofilter_spammable_id   :uuid             not null
#
# Indexes
#
#  index_oni_sorceress_analytics_spams_on_spammable  (oni_sorceress_bogofilter_spammable_type,oni_sorceress_bogofilter_spammable_id)
#
class OniSorceress::Analytics::BogofilterSpam < OniSorceressRecord
  include AASM

  belongs_to :oni_sorceress_bogofilter_spammable, polymorphic: true

  enum :learn_state, { not_learned: 0, learned: 1, unlearned: 2 }
  aasm :learn_state, enum: true do
    state :not_learned, initial: true
    state :learned
    state :unlearned

    event :learn, from: :not_learned, to: :learned
    event :unlearn, from: :learned, to: :unlearned
  end
end

app/models/oni_sorceress/analytics/request.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_analytics_requests
#
#  id                               :uuid             not null, primary key
#  application_server_request_end   :datetime
#  application_server_request_start :datetime
#  data                             :jsonb
#  oni_sorceress_requestable_type   :string
#  status_code                      :integer
#  uid                              :text
#  created_at                       :datetime         not null
#  updated_at                       :datetime         not null
#  oni_sorceress_requestable_id     :uuid
#
# Indexes
#
#  index_oni_sorceress_analytics_requests_on_requestable  (oni_sorceress_requestable_type,oni_sorceress_requestable_id)
#
class OniSorceress::Analytics::Request < OniSorceressRecord
  belongs_to :oni_sorceress_requestable, polymorphic: true, optional: true
end

app/models/oni_sorceress/analytics/spam_check.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_analytics_spam_checks
#
#  id                           :uuid             not null, primary key
#  classifier                   :integer          not null
#  oni_sorceress_spammable_type :string           not null
#  result                       :integer          not null
#  score                        :float            not null
#  created_at                   :datetime         not null
#  updated_at                   :datetime         not null
#  oni_sorceress_spammable_id   :uuid             not null
#
# Indexes
#
#  index_oni_sorceress_analytics_spam_checks_on_spammable  (oni_sorceress_spammable_type,oni_sorceress_spammable_id)
#
class OniSorceress::Analytics::SpamCheck < OniSorceressRecord
  belongs_to :oni_sorceress_spammable, polymorphic: true

  enum :classifier, { manual: 0, bogofilter: 1 }
  enum :result, { unsure: 0, spam: 1, ham: 2 }
end

app/models/oni_sorceress/content.rb
# frozen_string_literal: true

module ::OniSorceress::Content
  def self.table_name_prefix
    "oni_sorceress_content_"
  end
end

app/models/oni_sorceress/content/article.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_content_articles
#
#  id                                :uuid             not null, primary key
#  body                              :text
#  body_mime                         :text
#  hidden                            :boolean          default(FALSE), not null
#  last_updated_at                   :datetime
#  original_filename                 :text
#  posted_at                         :datetime
#  secret                            :text
#  title                             :text
#  title_mime                        :text
#  uri                               :text
#  created_at                        :datetime         not null
#  updated_at                        :datetime         not null
#  oni_sorceress_content_author_id   :uuid
#  oni_sorceress_content_category_id :uuid
#  oni_sorceress_content_license_id  :uuid
#  oni_sorceress_content_world_id    :uuid
#  pretty_id                         :text             not null
#
# Indexes
#
#  index_oni_sorceress_content_articles_on_author_id    (oni_sorceress_content_author_id)
#  index_oni_sorceress_content_articles_on_category_id  (oni_sorceress_content_category_id)
#  index_oni_sorceress_content_articles_on_license_id   (oni_sorceress_content_license_id)
#  index_oni_sorceress_content_articles_on_pretty_id    (pretty_id) UNIQUE
#  index_oni_sorceress_content_articles_on_world_id     (oni_sorceress_content_world_id)
#
# Foreign Keys
#
#  fk_rails_8c982eeadb  (oni_sorceress_content_author_id => oni_sorceress_content_authors.id)
#  fk_rails_a476655b71  (oni_sorceress_content_license_id => oni_sorceress_content_licenses.id)
#  fk_rails_c481d88894  (oni_sorceress_content_category_id => oni_sorceress_content_categories.id)
#  fk_rails_de2f5c8f1e  (oni_sorceress_content_world_id => oni_sorceress_content_worlds.id)
#
class OniSorceress::Content::Article < OniSorceressRecord
  belongs_to :author, class_name: "::OniSorceress::Content::Author", foreign_key: "oni_sorceress_content_author_id", inverse_of: :articles
  belongs_to :category, class_name: "::OniSorceress::Content::Category", foreign_key: "oni_sorceress_content_category_id", inverse_of: :articles
  has_many :articles_languages,
    class_name: "::OniSorceress::Content::ArticlesLanguage",
    foreign_key: "oni_sorceress_content_article_id",
    dependent: :destroy,
    inverse_of: :article
  has_many :languages, through: :articles_languages
  belongs_to :license, class_name: "::OniSorceress::Content::License", foreign_key: "oni_sorceress_content_license_id", inverse_of: :articles
  belongs_to :world, class_name: "::OniSorceress::Content::World", foreign_key: "oni_sorceress_content_world_id", inverse_of: :articles

  has_many :comments, as: :oni_sorceress_content_commentable, dependent: :destroy
  has_many :images, as: :oni_sorceress_content_imageable, dependent: :destroy
  has_many :image_galleries, as: :oni_sorceress_content_image_galleryable, dependent: :destroy
  has_many :videos, as: :oni_sorceress_content_videoable, dependent: :destroy

  validates :pretty_id, :title, :original_filename, :body, presence: true
  validate :same_world

  scope :listable, ->(world:) do
    includes(:author, :category, :world)
      .where(hidden: false, secret: nil)
      .where(last_updated_at: ...Time.now.utc)
      .where(world: { name: world })
      .order(last_updated_at: :desc, title: :asc)
  end

  scope :listable_for_first_level_category, ->(world:, name:) do
    listable(world:)
      .includes(:category)
      .where(category: { first_level: name })
  end

  private

  def same_world
    errors.add(:author, "must belong to the same world") if author && world != author.world
    errors.add(:category, "must belong to the same world") if category && world != category.world
    errors.add(:language, "all must belong to the same world") if languages.any? { |language| world != language.world }
    errors.add(:license, "must belong to the same world") if license && world != license.world
  end
end

app/models/oni_sorceress/content/articles_language.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_content_articles_languages
#
#  id                                :uuid             not null, primary key
#  priority                          :integer          default(1), not null
#  created_at                        :datetime         not null
#  updated_at                        :datetime         not null
#  oni_sorceress_content_article_id  :uuid             not null
#  oni_sorceress_content_language_id :uuid             not null
#
# Indexes
#
#  idx_on_oni_sorceress_content_article_id_oni_sorcere_327f950961  (oni_sorceress_content_article_id,oni_sorceress_content_language_id) UNIQUE
#  index_oni_sorceress_content_art_lang_on_article_id              (oni_sorceress_content_article_id)
#  index_oni_sorceress_content_art_lang_on_language_id             (oni_sorceress_content_language_id)
#
# Foreign Keys
#
#  fk_rails_59879288e1  (oni_sorceress_content_article_id => oni_sorceress_content_articles.id)
#  fk_rails_a8fb0dab09  (oni_sorceress_content_language_id => oni_sorceress_content_languages.id)
#
class OniSorceress::Content::ArticlesLanguage < OniSorceressRecord
  belongs_to :article, class_name: "::OniSorceress::Content::Article", foreign_key: "oni_sorceress_content_article_id", inverse_of: :articles_languages
  belongs_to :language, class_name: "::OniSorceress::Content::Language", foreign_key: "oni_sorceress_content_language_id", inverse_of: false

  validates :oni_sorceress_content_language_id, uniqueness: { scope: :oni_sorceress_content_article_id }
end

app/models/oni_sorceress/content/author.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_content_authors
#
#  id                             :uuid             not null, primary key
#  bio                            :text
#  name                           :text             not null
#  created_at                     :datetime         not null
#  updated_at                     :datetime         not null
#  oni_sorceress_content_world_id :uuid             not null
#
# Indexes
#
#  idx_on_oni_sorceress_content_world_id_name_c3b865a681  (oni_sorceress_content_world_id,name) UNIQUE
#  index_oni_sorceress_content_authors_on_world_id        (oni_sorceress_content_world_id)
#
# Foreign Keys
#
#  fk_rails_e47066d1b2  (oni_sorceress_content_world_id => oni_sorceress_content_worlds.id)
#
class OniSorceress::Content::Author < OniSorceressRecord
  belongs_to :world, class_name: "::OniSorceress::Content::World", foreign_key: "oni_sorceress_content_world_id", inverse_of: :authors
  has_many :articles, class_name: "::OniSorceress::Content::Article", foreign_key: "oni_sorceress_content_author_id", dependent: :destroy, inverse_of: :author

  validates :name, presence: true, uniqueness: { scope: :oni_sorceress_content_world_id }

  scope :for_world, ->(world) { includes(:world).where(world: { name: world }) }
end

app/models/oni_sorceress/content/category.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_content_categories
#
#  id                             :uuid             not null, primary key
#  first_level                    :text             not null
#  second_level                   :text             not null
#  created_at                     :datetime         not null
#  updated_at                     :datetime         not null
#  oni_sorceress_content_world_id :uuid             not null
#
# Indexes
#
#  index_oni_sorceress_content_categories_on_first_second_world  (first_level,second_level,oni_sorceress_content_world_id) UNIQUE
#  index_oni_sorceress_content_categories_on_world_id            (oni_sorceress_content_world_id)
#
# Foreign Keys
#
#  fk_rails_90d1cbdda4  (oni_sorceress_content_world_id => oni_sorceress_content_worlds.id)
#
class OniSorceress::Content::Category < OniSorceressRecord
  belongs_to :world, class_name: "::OniSorceress::Content::World", foreign_key: "oni_sorceress_content_world_id", inverse_of: :categories
  has_many :articles,
    class_name: "::OniSorceress::Content::Article",
    foreign_key: "oni_sorceress_content_category_id",
    dependent: :destroy,
    inverse_of: :category

  validates :first_level, presence: true
  validates :second_level, presence: true, uniqueness: { scope: [:first_level, :oni_sorceress_content_world_id] }

  scope :in_world, ->(world) do
    includes(:world)
      .joins(:articles)
      .where(world: { name: world })
      .where(articles: { hidden: false })
      .order(:first_level, :second_level)
  end

  scope :in_world_first_level, ->(world) do
    includes(:world)
      .joins(:articles)
      .where(world: { name: world })
      .where(articles: { hidden: false })
      .distinct
      .order(:first_level)
      .pluck(:first_level)
  end
end

app/models/oni_sorceress/content/comment.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: oni_sorceress_content_comments
#
#  id                                     :uuid             not null, primary key
#  body                                   :text             not null
#  oni_sorceress_content_commentable_type :string           not null
#  poster_name                            :text
#  published_at                           :datetime
#  created_at                             :datetime         not null
#  updated_at                             :datetime         not null
#  oni_sorceress_content_commentable_id   :uuid             not null
#
# Indexes
#
#  index_oni_sorceress_content_comment_on_commentable  (oni_sorceress_content_commentable_type,oni_sorceress_content_commentable_id)
#

class OniSorceress::Content::Comment < OniSorceressRecord
  belongs_to :oni_sorceress_content_commentable, polymorphic: true
  has_one :request, as: :oni_sorceress_requestable, class_name: "::OniSorceress::Analytics::Request", dependent: :destroy
  has_many :spam_checks, as: :oni_sorceress_spammable, class_name: "::OniSorceress::Analytics::SpamCheck", dependent: :destroy
  has_many :bogofilter_hams, as: :oni_sorceress_bogofilter_hammable, class_name: "::OniSorceress::Analytics::BogofilterHam", dependent: :destroy
  has_many :bogofilter_spams, as: :oni_sorceress_bogofilter_spammable, class_name: "::OniSorceress::Analytics::BogofilterSpam", dependent: :destroy

  validates :poster_name, length: { maximum: 100 }
  validates :body, presence: true, length: { maximum: 4000 }
  validates :request, presence: true

  scope :unpublished, -> { where(published_at: nil) }
  scope :without_manual_spam_check, -> {
    left_outer_joins(:spam_checks).where.not(spam_checks: { classifier: :manual }).or(where(spam_checks: { id: nil }))
  }
  scope :not_spam, -> {
    find_by_sql("#{joins(:spam_checks).where.not(spam_checks: { result: :spam }).to_sql} UNION #{where.missing(:spam_checks).to_sql}")
  }

  # def self.not_spam
  #  left_joins(:spam_checks).select do |comment|
  #    comment.spam_checks.empty? || comment.spam_checks.pluck(:result).all? { |item| item.in?(%w[ham unsure]) }
  #  end
  # end
end

app/views/oni_sorceress/layouts/_flashes.html.slim
- if flash.keys.any?
  .oni-container-narrow.oni-sorceress__flashes
    - flash.keys.each do |key|
      strong= flash[key]
      br

app/views/oni_sorceress/layouts/_footer.html.erb
<footer class="oni-footer">
  <div class="oni-footer__details">
    <ul class="oni-footer__details-list">
      <li>
        <span class="oni-footer__level1-symbol">&gt;</span> made in <a href="https://en.wikipedia.org/wiki/Slovakia">Slovakia</a>
        <a href="https://en.wikipedia.org/wiki/Slovakia"><%= image_tag 'slovakia.svg', alt: 'Map with Slovakia flag', class: 'oni-footer__country' %></a>
        and <a href="https://en.wikipedia.org/wiki/Czechia">Czechia</a>
        <a href="https://en.wikipedia.org/wiki/Czechia"><%= image_tag 'czechia.svg', alt: 'Map with Czechia flag', class: 'oni-footer__country' %></a>
      </li>
      <li><span class="oni-footer__level1-symbol">&gt;</span> anno <strong>2014</strong>, still alive in <strong><%= Time.zone.now.year %></strong></li>
      <li><span class="oni-footer__level1-symbol">&gt;</span> programming by <a href="<%= author_path('Ivan Alenko') %>">Ivan Alenko</a></li>
      <li><span class="oni-footer__level1-symbol">&gt;</span> syndications: <%= link_to 'Atom Feed', allfeed_atom_path %></li>
    </ul>

    <div class="oni-footer__specs">
      <h1 class="oni-footer__h1">&gt; running on & system specs</h1>
      <ul class="oni-footer__specs-list">
        <li><span class="oni-footer__level2-symbol">$</span> CMS: <a href="https://repo.or.cz/oni_sorceress.git" rel="noopener" target="_blank">Oni Sorceress</a></li>
        <li><span class="oni-footer__level2-symbol">$</span> web framework: <a href="http://rubyonrails.org/" rel="noopener" target="_blank">Ruby on Rails <%= Rails::VERSION::STRING %></a></li>
        <li><span class="oni-footer__level2-symbol">$</span> programming language: <a href="http://ruby-lang.org/" rel="noopener" target="_blank">Ruby <%= RUBY_VERSION %></a></li>
        <li><span class="oni-footer__level2-symbol">$</span> operating system: <a href="http://debian.org/" rel="noopener" target="_blank">Debian Linux</a></li>
      </ul>
    </div>    
  </div>

  <nav class="oni-footer__navigation">
    <ul class="oni-footer__navigation-list">
      <li><span class="oni-footer__level1-symbol">&gt;</span> <a href="<%= article_path('about') %>">About</a></li>
      <li><span class="oni-footer__level1-symbol">&gt;</span> <a href="<%= article_path('security') %>">Security</a></li>
      <li><span class="oni-footer__level1-symbol">&gt;</span> <a href="<%= browse_path %>">Browse All By Category</a></li>
      <li><span class="oni-footer__level1-symbol">&gt;</span> <a href="<%= what_is_my_ip_address_path %>">What Is My IP Address</a></li>
    </ul>
  </nav>
</footer>

app/views/oni_sorceress/layouts/_header.html.erb
<div class="oni-header">
  <div class="oni-logo"><a href="<%= root_url %>">myrtana.sk</a></div>
  <div class="oni-header__happy-slogan">Mind Dump, Tech And Life Blog</div>
</div>

app/views/oni_sorceress/layouts/application.html.erb
<!DOCTYPE html>
<html dir="ltr" lang="<%= @meta_language&.join(',') || @default_language %>">
<head>
  <meta charset='UTF-8'>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <% if @meta_description.present? %>
    <meta name="description" content="<%= @meta_description %>">
  <% end %>
  <% if @private_page %>
    <meta name="robots" content="noindex, nofollow, noarchive, nosnippet, notranslate, noimageindex">
  <% end %>
  <link rel="canonical" href="<%= url_for(only_path: false) %>" />
  <title><%= "#{yield(:page_title)} @ " if content_for? :page_title %><%= @title_suffix %></title>
  <%= stylesheet_link_tag 'application', media: 'all' %>
  <%= csrf_meta_tags %>

  <style>
    <% if @bg_landscape %>
      html { background-image: url('<%= image_path("#{@bg_landscape}_4k.jpg") %>'); }

      @media only screen and (max-width: 640px) {
        html { background-image: url('<%= image_path("#{@bg_landscape}_480.jpg") %>'); }
      }

      @media only screen and (max-width: 1280px) {
        html { background-image: url('<%= image_path("#{@bg_landscape}_720.jpg") %>'); }
      }

      @media only screen and (max-width: 1920px) {
        html { background-image: url('<%= image_path("#{@bg_landscape}_1080.jpg") %>'); }
      }
    <% end %>

    <% if @bg_portrait %>
      @media (orientation: portrait) {
        html { background-image: url('<%= image_path("#{@bg_portrait}_4k.jpg") %>'); }
      }

      @media (orientation: portrait) and only screen and (max-width: 640px) {
        html { background-image: url('<%= image_path("#{@bg_portrait}_480.jpg") %>'); }
      }

      @media (orientation: portrait) and only screen and (max-width: 1280px) {
        html { background-image: url('<%= image_path("#{@bg_portrait}_720.jpg") %>'); }
      }

      @media (orientation: portrait) and only screen and (max-width: 1920px) {
        html { background-image: url('<%= image_path("#{@bg_portrait}_1080.jpg") %>'); }
      }
    <% end %>
  </style>
</head>
<body class="oni">
  <%= render 'oni_sorceress/layouts/header' %>
  <%= render 'oni_sorceress/layouts/flashes' %>

  <div class="oni-content">
    <%= yield %>
  </div>

  <%= render 'oni_sorceress/layouts/footer' %>
</body>
</html>